stages:
  - build
  - test
  - release
  - deploy



build:
  image:
    name: golang:1.21.3-alpine
    entrypoint: ["/usr/bin/env"]
  stage: build
  before_script:
    - apk add build-base
  script:
    - go mod tidy
    - go build -o ./build/app cmd/app/main.go

unit-tests:
  needs: ["build"]
  image:
    name: golang:1.21.3-bookworm
    entrypoint: ["/usr/bin/env"]
  stage: test
  before_script:
    - go install github.com/pact-foundation/pact-go/v2@2.x.x
    - pact-go -l DEBUG install
  script:
    - go mod tidy
    - go test -cover -skip "^Test.*.Contract$" ./...

contract-tests-verify-contracts:
  needs: ["build"]
  image:
    name: golang:1.21.3-bookworm
    entrypoint: ["/usr/bin/env"]
  stage: test
  before_script:
    - go install github.com/pact-foundation/pact-go/v2@2.x.x
    - pact-go -l DEBUG install
    - export PACT_BROKER_BASE_URL=${PACT_BROKER_BASE_URL}
    - export PACT_BROKER_USERNAME=${PACT_BROKER_USERNAME}
    - export PACT_BROKER_PASSWORD=${PACT_BROKER_PASSWORD}
    - export PROVIDER_VERSION="$(cat VERSION)-${CI_COMMIT_SHA}"
    - export CI_GIT_BRANCH=${CI_COMMIT_BRANCH}
    - export PACT_URL=${PACT_URL}
  script:
    - go mod tidy
    - go test -cover -run "^Test.*.Contract$" ./...

can-i-deploy:
  needs: ["contract-tests-verify-contracts"]
  image:
    name: pactfoundation/pact-cli:latest
    entrypoint: ["/usr/bin/env"]
  stage: release
  before_script:
    - export PACT_BROKER_BASE_URL=${PACT_BROKER_BASE_URL}
    - export PACT_BROKER_USERNAME=${PACT_BROKER_USERNAME}
    - export PACT_BROKER_PASSWORD=${PACT_BROKER_PASSWORD}
  script:
    - pact-broker can-i-deploy --pacticipant provider --version "$(cat VERSION)-${CI_COMMIT_SHA}" --to-environment production
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "api"

release:
  needs: ["can-i-deploy"]
  image:
    name: alpine:latest
  stage: release
  script:
    - echo "FAKE_RELEASE_SUCCESS"
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "api"

deploy:
  needs: ["release"]
  image:
    name: pactfoundation/pact-cli:latest
    entrypoint: ["/usr/bin/env"]
  stage: deploy
  script:
    - echo "FAKE_DEPLOY_SUCCESS"
    - echo "NOTIFY PACT OF SERVICE DEPLOYMENT"
    - pact-broker record-deployment --pacticipant provider --version "$(cat VERSION)-${CI_COMMIT_SHA}" --environment production
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "api"

 